import { Event } from './Event';
import { IPlugin } from './interfaces/IPlugin';
export declare class PluginStore {
    private functionArray;
    private pluginMap;
    private _eventCallableRegistry;
    constructor();
    install(plugin: IPlugin): void;
    getInstalledPluginNameWithVersion(name: string): string | null;
    addFunction(key: string, fn: any): void;
    executeFunction(key: string, ...args: any): any;
    removeFunction(key: string): void;
    uninstall(key: string): void;
    addEventListener(name: string, callback: (event: Event) => void): void;
    removeEventListener(name: string, callback: (event: Event) => void): void;
    dispatchEvent(event: Event): void;
}
